//
// Created by webpigeon on 29/12/22.
//
#include <benchmark/benchmark.h>

#include "labs/sorting/lab1.hpp"

static void BM_MergeSort(benchmark::State& state) {
    // Perform setup here
    for (auto _ : state) {
        state.PauseTiming();
        auto list = generate_list(state.range(0));
        state.ResumeTiming();

        // This code gets timed
        merge_sort(list);
        benchmark::ClobberMemory();
    }

    // for big oh notation
    state.SetComplexityN(state.range(0));
}

static void BM_InsertionSort(benchmark::State& state) {
    // Perform setup here

    for (auto _ : state) {
        state.PauseTiming();
        auto list = generate_list(state.range(0));
        state.ResumeTiming();

        // This code gets timed
        insertion_sort(list);
        benchmark::ClobberMemory();
    }

    // for big oh notation
    state.SetComplexityN(state.range(0));
}

static void BM_BubbleSort(benchmark::State& state) {
    // Perform setup here
    for (auto _ : state) {
        state.PauseTiming();
        auto list = generate_list(state.range(0));
        state.ResumeTiming();

        // This code gets timed
        bubble_sort(list);
        benchmark::ClobberMemory();
    }

    // for big oh notation
    state.SetComplexityN(state.range(0));
}

static void BM_SelectionSort(benchmark::State& state) {
    // Perform setup here
    for (auto _ : state) {
        state.PauseTiming();
        auto list = generate_list(state.range(0));
        state.ResumeTiming();

        // This code gets timed
        selection_sort(list);
        benchmark::ClobberMemory();
    }
    
    // for big oh notation
    state.SetComplexityN(state.range(0));
}

// Register the function as a benchmark
BENCHMARK(BM_MergeSort) ->RangeMultiplier(2)->Range(1<<10, 1<<16)->Complexity();
BENCHMARK(BM_InsertionSort) ->RangeMultiplier(2)->Range(1<<10, 1<<16)->Complexity();
BENCHMARK(BM_BubbleSort) ->RangeMultiplier(2)->Range(1<<10, 1<<16)->Complexity();
BENCHMARK(BM_SelectionSort) ->RangeMultiplier(2)->Range(1<<10, 1<<16)->Complexity();

// Run the benchmark
BENCHMARK_MAIN();